//+------------------------------------------------------------------+
//|                                                    CCIArrows.mq4 |
//|                          Copyright  2011, Forex-Programming.com |
//|                                 http://www.forex-programming.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2011, Forex-Programming.com"
#property link      "http://www.forex-programming.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green

double dUpCCIBuffer[];
double dDownCCIBuffer[];
double dSellBuffer[];

extern int CCI_Period = 14;
extern bool Alerts = true;
extern string Alert_Sound = "alert.wav";
 
int RowNum = 0;
int LastTrend = -1;
int UP_IND    = 1;
int DOWN_IND  = 0;

datetime alert_time;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
    SetIndexBuffer(0,dUpCCIBuffer);
    SetIndexBuffer(1,dDownCCIBuffer);  
    SetIndexBuffer(2,dSellBuffer); 

    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,233); 
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,234); 
    SetIndexStyle(2,DRAW_ARROW);
    SetIndexArrow(2,252);  
    
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    SetIndexEmptyValue(2,0.0);
    
    SetIndexLabel(0,"CCI Buy");
    SetIndexLabel(1,"CCI Sell");
    SetIndexLabel(2,"Exit");

    Comment("www.Forex-Programming.com");

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
  
   return(0);
  }
  


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int nBars,nCountedBars;

   nCountedBars=IndicatorCounted(); 
//---- check for possible errors
   if(nCountedBars<0) return(-1);
//---- last counted bar will be recounted    
   if(nCountedBars<=3)nBars=Bars-nCountedBars-4;
    
   if(nCountedBars>2)
    {
     nCountedBars--;
     nBars=Bars-nCountedBars-1; 
    }

   int lastCloseLong=0;
   int lastCloseShort=0;

   for (int i=Bars; i>0; i--)
    {
     dUpCCIBuffer[i]=0;
     dDownCCIBuffer[i]=0;

     double myCCInow = iCCI(NULL,0,CCI_Period,PRICE_CLOSE,i);
     double myCCI2 = iCCI(NULL,0,CCI_Period,PRICE_CLOSE,i+1); 
      
     if (myCCInow>=0)
      {
       if(myCCInow>0 && myCCI2<0) 
        {
         dUpCCIBuffer[i] = Low[i] - 2 * MarketInfo(Symbol(),MODE_POINT);
        }
      }
     if(myCCInow<0) 
      {
       if(myCCInow<0 && myCCI2>0) 
        {
         dDownCCIBuffer[i] = High[i] + 2 * MarketInfo(Symbol(),MODE_POINT);
        }
      } 
    }
    
   if (!Alerts)return(0);
   
   if (dUpCCIBuffer[1]!=EMPTY_VALUE && dUpCCIBuffer[1]!=0)
    {
     if (Time[0]>alert_time)Alert(Symbol(), "- CCI has crossed up!");
     PlaySound(Alert_Sound);
     alert_time=Time[0];
    }
   if (dDownCCIBuffer[1]!=EMPTY_VALUE && dDownCCIBuffer[1]!=0)
    {
     if (Time[0]>alert_time)Alert(Symbol(), "- CCI has crossed down!");
     PlaySound(Alert_Sound);
     alert_time=Time[0];
    }
    
    
   return(0);
  }

